QGIS Application - Feature request #7611
Title case option which also operates on uppercase words
2013-04-14 05:15 AM - Nyall Dawson

Status: Reopened

Priority: Normal

Assignee:

Category: Labelling

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 16539
Description

Setting a type case of "Title case" has no effect on the way labels are rendered when the text is already in upper case. For example, in the
attached image "KNOX" is rendered as "KNOX", not "Knox". The other case settings (All uppercase/lowercase) work as expected.

EDIT
As discussed, "Title case" has been renamed "capitalize first letter”, so this is now a feature request for a "Title case" feature, which would
also lowercase subsequent letters.

Related issues:

Related to QGIS Application - Bug report # 7724: Label type cases do not alte... Closed 2013-04-27
Related to QGIS Application - Feature request # 8938: More text formatting op... Closed 2013-10-23
Duplicated by QGIS Application - Bug report # 12804: The Label Option: FirstC... Closed 2015-05-21
History

#1 - 2013-04-14 07:54 AM - Borys Jurgiel
- Resolution set to invalid

I wouldn't expect the title() function will convert upper case characters to lower case. It would be a regression, as you couldn't create labels like "Quantum

GIS Headquarters". In your case you can simply use: title(lower(lga_name))

I'm closing the ticket, but of course feel free to reopen if you disagree or | misunderstood something.

#2 - 2013-04-14 07:54 AM - Borys Jurgiel

- Status changed from Open to Closed

#3 - 2013-04-14 08:09 AM - Larry Shaffer

- Status changed from Closed to Reopened

- Resolution deleted (invalid)

Hi Nyall,

The Title case used there in labeling is Qt's 'Capitalize' from QFont enum Capitalization:

QFont::Capitalize 4 This alters the text to be rendered with the first character of each word as an uppercase character.

However, this differs from how page-layout programs and the 'title' function in the Expression editor work. Usually, setting title case will convert uppercase

letters to lowercase, as is done in the title function.
http://qt-project.org/doc/qt-4.7/qfont.html#id-467833f3-6151-4157-a9f3-8dad38515ff7
http://grammar.about.com/od/tz/g/Title-Case.htm
http://grammar.about.com/od/tz/g/Title-Case.htm

| propose to rename the Title function Nyall refers to as 'Capitalize' or 'Capitalize first letter' instead, so there is no confusion.

#4 - 2013-04-14 03:50 PM - Nyall Dawson

Borys - that makes sense, but as Larry pointed out it's a bit confusing for users. My vote would be to change the wording to "Capitalize first letter", since

that makes it a bit clearer that it only applies to the first letter and not the rest of the letters.

#5 - 2013-04-16 03:44 PM - Nyall Dawson

Borys - after thinking about this, I'm a little puzzled what the use case is for your example. Are you saying you have a value in your table with mixed but

predominantly lower-case characters ("quantum GIS headquarters")? Wouldn't it be much more common to have either all lower-case or all upper-case

values in a table? Or is this function designed more for converting sentences like "Located at quantum GIS headquarters."?

#6 - 2013-04-17 11:06 AM - Borys Jurgiel

Maybe my example was too abstract, better one would be POI names that are sometimes acronyms. | prefer to be forced to use the two functions

capitalize(lower(lga_name)) over having no way to preserve acronyms. Of course the best would be to have both capitalize() and title().

But maybe it's not so important. Usually | have the luck to work on properly prepared data, so | don't have much experience with correcting poor data at this

stage. | don't insist anymore :)

#7 - 2013-04-17 02:34 PM - Nyall Dawson

Lucky -- Almost all the data | work with is poorly formatted! Anyway, | think the best resolution would be renaming Title case -> Capitalize First Letter for
now, and then ideally adding a proper "Title case" option after 2.0. We could even make it handle fancy things like not capitalizing "a" or "the" when they're

in the middle of a string...

#8 - 2014-06-28 07:43 AM - Juirgen Fischer
- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#9 - 2015-06-16 07:15 PM - Alister Hood
- Tracker changed from Bug report to Feature request

- Subject changed from Title case has no effect to Title case option which also operates on uppercase words

#10 - 2017-05-01 12:48 AM - Giovanni Manghi
- Easy fix? set to No

Files

title_case.png 260 KB 2013-04-14 Nyall Dawson

2025-04-26 22



